/*
****************************************************************************
****************************************************************************
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                           BIAYSTOK 2014                               **
**                                                                        **
**                         Home Control System                            **
**                                                                        **
**                              HC_TMPS1                                  **
**                      Wersja z dnia : 2017.12.09                        **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/
/*

        Specyfikacje EEPROM:
        GeneralEEPROM                   - wariant standardowy
        Display1EEPROM                  - wyswietlacz
        Display2EEPROM                  - wyswietlacz
        Display3EEPROM                  - wyswietlacz
        Display4EEPROM                  - wyswietlacz
        Display5EEPROM                  - wyswietlacz
*/

//#define GeneralEEPROM
//#define Display1EEPROM
#define Display2EEPROM
//#define Display3EEPROM
//#define Display4EEPROM
//#define Display5EEPROM



#include "scr1eeprom.h"
#include <inttypes.h>
#include <avr/pgmspace.h>

#define null 0

EEPROMBlockDataRecT EEBlock ;


//********************************************************************
#ifdef GeneralEEPROM
// GeneralEEPROM - wariant standardowy
static uint8_t MyDefaultID [ ] PROGMEM               = "SCR1" ;
#endif
//********************************************************************
#ifdef Display1EEPROM
// GeneralEEPROM - wariant standardowy
static uint8_t MyDefaultID [ ] PROGMEM               = "SCR01" ;
#endif
//********************************************************************
#ifdef Display2EEPROM
// GeneralEEPROM - wariant standardowy
static uint8_t MyDefaultID [ ] PROGMEM               = "SCR02" ;
#endif
//********************************************************************
#ifdef Display3EEPROM
// GeneralEEPROM - wariant standardowy
static uint8_t MyDefaultID [ ] PROGMEM               = "SCR03" ;
#endif
//********************************************************************
#ifdef Display4EEPROM
// GeneralEEPROM - wariant standardowy
static uint8_t MyDefaultID [ ] PROGMEM               = "SCR04" ;
#endif
//********************************************************************
#ifdef Display5EEPROM
// GeneralEEPROM - wariant standardowy
static uint8_t MyDefaultID [ ] PROGMEM               = "SCR05" ;
#endif





static void EEPROMClearBlock ( void *   Destination ,
                               uint16_t Size )
{
  uint16_t Loop ;
  uint8_t * Dst ;
  /*----------------------------------------------------------------*/
  Dst = ( uint8_t * ) Destination ;
  for ( Loop = 0 ; Loop < Size ; Loop ++ )
    * Dst ++ = null ;
} /* EEPROMClearBlock */


static void SetIDFlash ( uint8_t * DeviceID , 
                         uint16_t  String )
{
  uint8_t Data ;
  uint8_t Loop ;
  uint8_t * DestCh ;
  /*----------------------------------------------------------------*/
  DestCh = DeviceID ;
  for ( Loop = 0 ; Loop <= DeviceIDSize ; Loop ++ )
    * DestCh ++ = null ;
  DestCh = DeviceID ;
  for ( Loop = 0 ; Loop < DeviceIDSize ; Loop ++ )
  {
    Data = pgm_read_byte_near ( String ++ ) ;
    if ( Data )
      * DestCh ++ = Data ;
    else
      break ;
  } /* for */ ;
} /* SetIDFlash */


void SetDefaultEEBlock ( void )
{
  /*----------------------------------------------------------------*/
  EEPROMClearBlock ( & EEBlock , sizeof ( EEPROMBlockDataRecT ) ) ;
  EEBlock . EEBlockMetric = StandardSygnature ;
  SetIDFlash ( EEBlock . MyDeviceID , ( uint16_t ) MyDefaultID ) ;
  EEBlock . Password [ 0 ] = 'M' ;
  EEBlock . Password [ 1 ] = 'A' ;
  EEBlock . Password [ 2 ] = 'G' ;
  EEBlock . Password [ 3 ] = 'I' ;
  EEBlock . Password [ 4 ] = 'C' ;
  EEBlock . Password [ 5 ] = null ;
  EEBlock . CRCValue = 0 ;
} /* SetDefaultEEBlock */


